#ifndef MSP_HTTP_REQUEST_H_
#define MSP_HTTP_REQUEST_H_

#include <string>
#include "message.h"

namespace Msp {
namespace Http {

class Request: public Message
{
private:
	std::string method;
	std::string path;

public:
	Request(const std::string &, const std::string &);
	const std::string &get_method() const { return method; }
	const std::string &get_path() const { return path; }
	virtual std::string str() const;

	static Request parse(const std::string &);
	static Request from_url(const std::string &);
};

} // namespace Http
} // namespace Msp

#endif
