#ifndef MSP_NET_INET6_H_
#define NSP_NET_INET6_H_

#include "sockaddr.h"

namespace Msp {
namespace Net {

class Inet6Addr: public SockAddr
{
private:
	unsigned char addr[16];
	unsigned port;

public:
	Inet6Addr();
	Inet6Addr(const SysAddr &);

	virtual Inet6Addr *copy() const { return new Inet6Addr(*this); }

	virtual SysAddr to_sys() const;

	virtual Family get_family() const { return INET6; }
	unsigned get_port() const { return port; }
	virtual std::string str() const;
};

} // namespace Net
} // namespace Msp

#endif
