#ifndef MSP_NET_SERVERSOCKET_H_
#define MSP_NET_SERVERSOCKET_H_

#include "socket.h"

namespace Msp {
namespace Net {

class ClientSocket;

/**
ServerSockets are used to receive incoming connections.  They cannot be used
for sending and receiving data.
*/
class ServerSocket: public Socket
{
protected:
	ServerSocket(Family, int, int);

public:
	virtual void listen(const SockAddr &, unsigned = 4) = 0;

	virtual ClientSocket *accept() = 0;
protected:
	virtual unsigned do_write(const char *, unsigned);
	virtual unsigned do_read(char *, unsigned);
};

} // namespace Net
} // namespace Msp

#endif
